(* EPITA SPE 2010/2011       *)
(* Contrôle 2 - Février 2011 *)
(* test - question05         *)

module Q = Question05

let i2s i =
  Printf.sprintf "%03d" i

let makeNode =
  let c = ref (-1) in
    function () ->
      incr c; "node"^(i2s !c)

let rec build_tree = function
  | 0 -> Q.Empty
  | d ->
      let k = makeNode () in
      let ls = build_tree (d-1) in
      let rs = build_tree (d-1) in
	Q.Node (ls, k, rs)

let rec print_tree = function
  | Q.Empty -> Format.printf "@[<b>Empty@]@;"
  | Q.Node(ls,k,rs) ->
      begin
	Format.printf "@[<b>Node(@[<b>@,";
	print_tree ls;
	Format.printf ",@, %s,@;" k;
	print_tree rs;
	Format.printf "@]@,)@]"
      end

let thsize n = (1 lsl n) - 1

let print t =
  Format.printf "@[<v 2>t =@,";
  print_tree t;
  Format.printf "@]@."

let print_order (k,(op,os)) =
  Format.printf "@,@[<b 2>(%s,%d,%d)@]" k op os

let to_list h =
  Hashtbl.fold (fun k v l -> (k,v)::l) h []

let print_ordering h =
  Format.printf "@[<v>h = {@[<v>";
  List.iter print_order (List.sort compare (to_list h));
  Format.printf "@]@,}@]@."

let main () =
  begin
    let q = new Test_frame.qSizeString 5 4 in
      q#beginParse;
      q#init;
      let n = q#getSize in
      let t = build_tree n in
	print t;
	let (h,c) = Q.ordering t in
	  Format.printf "(h,c) = ordering t@.";
	  Format.printf "@[<v>c = %d (should be %d)@."
	    c (2 * thsize n);
	  print_ordering h;
	exit 0;
  end

let _ = main ()
