/* EPITA SPE 2010/2011       */
/* Contrôle 2 - Février 2011 */
/* question12                */

#define QNUM 12
#define QOPT "graine size"
#define QNOPT 2

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "base_test.h"
#include "question12.h"

#define align(X) (8 + ((((X)-1)>>3)<<3))

#define randChar ((char)('a' + (random()%26)))

void randomString(char s[], size_t len)
{
  for (unsigned i=0; i<len; i++)
    s[i] = randChar;
}

void print(char d[], size_t len)
{
  char			b[9];
  int			ignore;
  size_t		j=0;
  for (size_t i=0; i<len; i++)
    {
      b[j] = d[i];
      j = (j+1)%8;
      if (!j)
	{
	  b[8] = '\n';
	  ignore = write(STDOUT_FILENO,b,9);
	}
    }
}

void freeblock(void *d, size_t len)
{
  uint64_t*x;x=d;len>>=3;
  for(unsigned i=0;i<len;i++,x++)*x^=*x;free(d);
}

int main(int argc,char *argv[])
{
  size_t        size;
  void	       *data, *copy;

  help_asked(argc,argv,QNUM,QOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = align(getSize(argv));
      data = malloc(size);
      copy = malloc(size + 4);
      *((uint32_t*)(size + (char*)copy)) = 29792;

      printf("size aligned to %d\n",size);
      randomString(data, size);
      printf("data[%d] =\n",size);
      print(data, size);

      printf("\nfastcopy(data,copy,%d)\n",size);
      fastcopy(data, copy, size);
      if (*((uint32_t*)(size + (char*)copy)) != 29792)
	{
	  fprintf(stderr,"copie en dehors du bloc !\n");
	  abort();
	}
      freeblock(data,size);

      printf("copy[%d] =\n",size);
      print(copy, size);
      free(copy);
    }
  exit(0);
}
